<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: peer/proposal_response.proto

namespace Hyperledger\Fabric\Protos\Peer;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An endorsement is a signature of an endorser over a proposal response.  By
 * producing an endorsement message, an endorser implicitly "approves" that
 * proposal response and the actions contained therein. When enough
 * endorsements have been collected, a transaction can be generated out of a
 * set of proposal responses.  Note that this message only contains an identity
 * and a signature but no signed payload. This is intentional because
 * endorsements are supposed to be collected in a transaction, and they are all
 * expected to endorse a single proposal response/action (many endorsements
 * over a single proposal response)
 *
 * Generated from protobuf message <code>protos.Endorsement</code>
 */
class Endorsement extends \Google\Protobuf\Internal\Message
{
    /**
     * Identity of the endorser (e.g. its certificate)
     *
     * Generated from protobuf field <code>bytes endorser = 1;</code>
     */
    private $endorser = '';
    /**
     * Signature of the payload included in ProposalResponse concatenated with
     * the endorser's certificate; ie, sign(ProposalResponse.payload + endorser)
     *
     * Generated from protobuf field <code>bytes signature = 2;</code>
     */
    private $signature = '';

    public function __construct() {
        \GPBMetadata\Peer\ProposalResponse::initOnce();
        parent::__construct();
    }

    /**
     * Identity of the endorser (e.g. its certificate)
     *
     * Generated from protobuf field <code>bytes endorser = 1;</code>
     * @return string
     */
    public function getEndorser()
    {
        return $this->endorser;
    }

    /**
     * Identity of the endorser (e.g. its certificate)
     *
     * Generated from protobuf field <code>bytes endorser = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setEndorser($var)
    {
        GPBUtil::checkString($var, False);
        $this->endorser = $var;

        return $this;
    }

    /**
     * Signature of the payload included in ProposalResponse concatenated with
     * the endorser's certificate; ie, sign(ProposalResponse.payload + endorser)
     *
     * Generated from protobuf field <code>bytes signature = 2;</code>
     * @return string
     */
    public function getSignature()
    {
        return $this->signature;
    }

    /**
     * Signature of the payload included in ProposalResponse concatenated with
     * the endorser's certificate; ie, sign(ProposalResponse.payload + endorser)
     *
     * Generated from protobuf field <code>bytes signature = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setSignature($var)
    {
        GPBUtil::checkString($var, False);
        $this->signature = $var;

        return $this;
    }

}

