<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: peer/proposal.proto

namespace Hyperledger\Fabric\Protos\Peer;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A Proposal is sent to an endorser for endorsement.  The proposal contains:
 * 1. A header which should be unmarshaled to a Header message.  Note that
 *    Header is both the header of a Proposal and of a Transaction, in that i)
 *    both headers should be unmarshaled to this message; and ii) it is used to
 *    compute cryptographic hashes and signatures.  The header has fields common
 *    to all proposals/transactions.  In addition it has a type field for
 *    additional customization. An example of this is the ChaincodeHeaderExtension
 *    message used to extend the Header for type CHAINCODE.
 * 2. A payload whose type depends on the header's type field.
 * 3. An extension whose type depends on the header's type field.
 * Let us see an example. For type CHAINCODE (see the Header message),
 * we have the following:
 * 1. The header is a Header message whose extensions field is a
 *    ChaincodeHeaderExtension message.
 * 2. The payload is a ChaincodeProposalPayload message.
 * 3. The extension is a ChaincodeAction that might be used to ask the
 *    endorsers to endorse a specific ChaincodeAction, thus emulating the
 *    submitting peer model.
 *
 * Generated from protobuf message <code>protos.Proposal</code>
 */
class Proposal extends \Google\Protobuf\Internal\Message
{
    /**
     * The header of the proposal. It is the bytes of the Header
     *
     * Generated from protobuf field <code>bytes header = 1;</code>
     */
    private $header = '';
    /**
     * The payload of the proposal as defined by the type in the proposal
     * header.
     *
     * Generated from protobuf field <code>bytes payload = 2;</code>
     */
    private $payload = '';
    /**
     * Optional extensions to the proposal. Its content depends on the Header's
     * type field.  For the type CHAINCODE, it might be the bytes of a
     * ChaincodeAction message.
     *
     * Generated from protobuf field <code>bytes extension = 3;</code>
     */
    private $extension = '';

    public function __construct() {
        \GPBMetadata\Peer\Proposal::initOnce();
        parent::__construct();
    }

    /**
     * The header of the proposal. It is the bytes of the Header
     *
     * Generated from protobuf field <code>bytes header = 1;</code>
     * @return string
     */
    public function getHeader()
    {
        return $this->header;
    }

    /**
     * The header of the proposal. It is the bytes of the Header
     *
     * Generated from protobuf field <code>bytes header = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setHeader($var)
    {
        GPBUtil::checkString($var, False);
        $this->header = $var;

        return $this;
    }

    /**
     * The payload of the proposal as defined by the type in the proposal
     * header.
     *
     * Generated from protobuf field <code>bytes payload = 2;</code>
     * @return string
     */
    public function getPayload()
    {
        return $this->payload;
    }

    /**
     * The payload of the proposal as defined by the type in the proposal
     * header.
     *
     * Generated from protobuf field <code>bytes payload = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPayload($var)
    {
        GPBUtil::checkString($var, False);
        $this->payload = $var;

        return $this;
    }

    /**
     * Optional extensions to the proposal. Its content depends on the Header's
     * type field.  For the type CHAINCODE, it might be the bytes of a
     * ChaincodeAction message.
     *
     * Generated from protobuf field <code>bytes extension = 3;</code>
     * @return string
     */
    public function getExtension()
    {
        return $this->extension;
    }

    /**
     * Optional extensions to the proposal. Its content depends on the Header's
     * type field.  For the type CHAINCODE, it might be the bytes of a
     * ChaincodeAction message.
     *
     * Generated from protobuf field <code>bytes extension = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setExtension($var)
    {
        GPBUtil::checkString($var, False);
        $this->extension = $var;

        return $this;
    }

}

