<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: peer/proposal_response.proto

namespace Hyperledger\Fabric\Protos\Peer;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A ProposalResponse is returned from an endorser to the proposal submitter.
 * The idea is that this message contains the endorser's response to the
 * request of a client to perform an action over a chaincode (or more
 * generically on the ledger); the response might be success/error (conveyed in
 * the Response field) together with a description of the action and a
 * signature over it by that endorser.  If a sufficient number of distinct
 * endorsers agree on the same action and produce signature to that effect, a
 * transaction can be generated and sent for ordering.
 *
 * Generated from protobuf message <code>protos.ProposalResponse</code>
 */
class ProposalResponse extends \Google\Protobuf\Internal\Message
{
    /**
     * Version indicates message protocol version
     *
     * Generated from protobuf field <code>int32 version = 1;</code>
     */
    private $version = 0;
    /**
     * Timestamp is the time that the message
     * was created as  defined by the sender
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp timestamp = 2;</code>
     */
    private $timestamp = null;
    /**
     * A response message indicating whether the
     * endorsement of the action was successful
     *
     * Generated from protobuf field <code>.protos.Response response = 4;</code>
     */
    private $response = null;
    /**
     * The payload of response. It is the bytes of ProposalResponsePayload
     *
     * Generated from protobuf field <code>bytes payload = 5;</code>
     */
    private $payload = '';
    /**
     * The endorsement of the proposal, basically
     * the endorser's signature over the payload
     *
     * Generated from protobuf field <code>.protos.Endorsement endorsement = 6;</code>
     */
    private $endorsement = null;

    public function __construct() {
        \GPBMetadata\Peer\ProposalResponse::initOnce();
        parent::__construct();
    }

    /**
     * Version indicates message protocol version
     *
     * Generated from protobuf field <code>int32 version = 1;</code>
     * @return int
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Version indicates message protocol version
     *
     * Generated from protobuf field <code>int32 version = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkInt32($var);
        $this->version = $var;

        return $this;
    }

    /**
     * Timestamp is the time that the message
     * was created as  defined by the sender
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp timestamp = 2;</code>
     * @return \Google\Protobuf\Timestamp
     */
    public function getTimestamp()
    {
        return $this->timestamp;
    }

    /**
     * Timestamp is the time that the message
     * was created as  defined by the sender
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp timestamp = 2;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setTimestamp($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->timestamp = $var;

        return $this;
    }

    /**
     * A response message indicating whether the
     * endorsement of the action was successful
     *
     * Generated from protobuf field <code>.protos.Response response = 4;</code>
     * @return \Hyperledger\Fabric\Protos\Peer\Response
     */
    public function getResponse()
    {
        return $this->response;
    }

    /**
     * A response message indicating whether the
     * endorsement of the action was successful
     *
     * Generated from protobuf field <code>.protos.Response response = 4;</code>
     * @param \Hyperledger\Fabric\Protos\Peer\Response $var
     * @return $this
     */
    public function setResponse($var)
    {
        GPBUtil::checkMessage($var, \Hyperledger\Fabric\Protos\Peer\Response::class);
        $this->response = $var;

        return $this;
    }

    /**
     * The payload of response. It is the bytes of ProposalResponsePayload
     *
     * Generated from protobuf field <code>bytes payload = 5;</code>
     * @return string
     */
    public function getPayload()
    {
        return $this->payload;
    }

    /**
     * The payload of response. It is the bytes of ProposalResponsePayload
     *
     * Generated from protobuf field <code>bytes payload = 5;</code>
     * @param string $var
     * @return $this
     */
    public function setPayload($var)
    {
        GPBUtil::checkString($var, False);
        $this->payload = $var;

        return $this;
    }

    /**
     * The endorsement of the proposal, basically
     * the endorser's signature over the payload
     *
     * Generated from protobuf field <code>.protos.Endorsement endorsement = 6;</code>
     * @return \Hyperledger\Fabric\Protos\Peer\Endorsement
     */
    public function getEndorsement()
    {
        return $this->endorsement;
    }

    /**
     * The endorsement of the proposal, basically
     * the endorser's signature over the payload
     *
     * Generated from protobuf field <code>.protos.Endorsement endorsement = 6;</code>
     * @param \Hyperledger\Fabric\Protos\Peer\Endorsement $var
     * @return $this
     */
    public function setEndorsement($var)
    {
        GPBUtil::checkMessage($var, \Hyperledger\Fabric\Protos\Peer\Endorsement::class);
        $this->endorsement = $var;

        return $this;
    }

}

